<?php

namespace Drupal\toggle_channels\Logger;

use Drupal\Core\Config\ConfigFactoryInterface;
use Drupal\toggle_channels\Form\SettingsForm;
use Psr\Log\LoggerInterface;

/**
 * Class that will disable the logging.
 */
class NullableLogger implements LoggerInterface {
  /**
   * Config.
   *
   * @var \Drupal\Core\Config\ImmutableConfig
   */
  protected $config;

  /**
   * ConfigurableLogger constructor.
   *
   * @param \Drupal\Core\Config\ConfigFactoryInterface $configFactory
   *   Config factory.
   */
  public function __construct(ConfigFactoryInterface $configFactory) {
    $this->config = $configFactory->get(SettingsForm::SETTINGS);
  }

  /**
   * {@inheritDoc}
   */
  public function log($level, $message, array $context = []) {}

  /**
   * {@inheritDoc}
   */
  public function info($message, array $context = []) {}

  /**
   * {@inheritDoc}
   */
  public function error($message, array $context = []) {}

  /**
   * {@inheritDoc}
   */
  public function notice($message, array $context = []) {}

  /**
   * {@inheritDoc}
   */
  public function warning($message, array $context = []) {}

  /**
   * {@inheritDoc}
   */
  public function critical($message, array $context = []) {}

  /**
   * {@inheritDoc}
   */
  public function alert($message, array $context = []) {}

  /**
   * {@inheritDoc}
   */
  public function debug($message, array $context = []) {}

  /**
   * {@inheritDoc}
   */
  public function emergency($message, array $context = []) {}

}
